Index: apps/app_voicemail.c
===================================================================
--- apps/app_voicemail.c	(revision 50404)
+++ apps/app_voicemail.c	(working copy)
@@ -2050,7 +2050,7 @@
 		snprintf(fname, sizeof(fname), "%s.%s", attach, format);
 		base_encode(fname, p);
 		/* only attach if necessary */
-		if (imap && strcmp(format, "gsm")) {
+		if (imap && (strcmp(format, "gsm") == 0)) {
 			fprintf(p, "--%s\r\n", bound);
 			fprintf(p, "Content-Type: audio/x-gsm; name=\"msg%04d.%s\"\r\n", msgnum, format);
 			fprintf(p, "Content-Transfer-Encoding: base64\r\n");
@@ -4661,11 +4661,23 @@
 		snprintf(vms->vmbox, sizeof(vms->vmbox), "vm-%s", vms->curbox);
 	}
 
+	// build up the folder specification string
+	snprintf(tmp, sizeof(tmp), "{%s:%s/imap", imapserver, imapport);
+
 	if (strlen(authuser) > 0) {
-		snprintf(tmp, sizeof(tmp), "{%s:%s/imap/authuser=%s/%s/user=%s}",imapserver,imapport,authuser,imapflags,vms->imapuser);
-	} else {
-		snprintf(tmp, sizeof(tmp), "{%s:%s/imap/%s/user=%s}",imapserver,imapport,imapflags,vms->imapuser);
-	}
+		strncat(tmp, "/", sizeof(tmp) - 1);
+		strncat(tmp, authuser, sizeof(tmp) - strlen(authuser));
+		}
+
+	if(strlen(imapflags) > 0) {
+		strncat(tmp, "/", sizeof(tmp) - 1);
+		strncat(tmp, imapflags, sizeof(tmp) - strlen(imapflags));
+		}
+
+	strncat(tmp, "/user=", sizeof(tmp) - 6);
+	strncat(tmp, vms->imapuser, sizeof(tmp) - strlen(vms->imapuser));
+	strncat(tmp, "}", sizeof(tmp) - 1);
+
 	if(box == 0 || box == 1)
 		sprintf(spec, "%s%s", tmp, use_folder? imapfolder: "INBOX");
 	else
